Index: sansmodels/src/sans/models/CoreFourShellModel.py
===================================================================
--- sansmodels/src/sans/models/CoreFourShellModel.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/CoreFourShellModel.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -37,6 +37,6 @@
     List of default parameters:
          scale           = 1.0 
-         rad_core        = 60.0 [A]
-         sld_core        = 6.4e-006 [1/A^(2)]
+         rad_core0       = 60.0 [A]
+         sld_core0       = 6.4e-006 [1/A^(2)]
          thick_shell1    = 10.0 [A]
          sld_shell1      = 1e-006 [1/A^(2)]
@@ -64,6 +64,6 @@
         self.description =""" Calculates the scattering intensity from a core-4 shell structure.
 		scale = scale factor * volume fraction
-		rad_core: the radius of the core
-		sld_core: the SLD of the core
+		rad_core0: the radius of the core
+		sld_core0: the SLD of the core
 		thick_shelli: the thickness of the i'th shell from the core
 		sld_shelli: the SLD of the i'th shell from the core
@@ -74,6 +74,6 @@
         self.details = {}
         self.details['scale'] = ['', None, None]
-        self.details['rad_core'] = ['[A]', None, None]
-        self.details['sld_core'] = ['[1/A^(2)]', None, None]
+        self.details['rad_core0'] = ['[A]', None, None]
+        self.details['sld_core0'] = ['[1/A^(2)]', None, None]
         self.details['thick_shell1'] = ['[A]', None, None]
         self.details['sld_shell1'] = ['[1/A^(2)]', None, None]
@@ -88,5 +88,5 @@
 
         ## fittable parameters
-        self.fixed=['thick_shell4.width', 'thick_shell1.width', 'thick_shell2.width', 'thick_shell3.width', 'rad_core.width']
+        self.fixed=['thick_shell4.width', 'thick_shell1.width', 'thick_shell2.width', 'thick_shell3.width', 'rad_core0.width']
         
         ## non-fittable parameters
Index: sansmodels/src/sans/models/CoreMultiShellModel.py
===================================================================
--- sansmodels/src/sans/models/CoreMultiShellModel.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/CoreMultiShellModel.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -3,5 +3,5 @@
 from sans.models.CoreFourShellModel import CoreFourShellModel
 import copy
-max_nshells = 4
+max_nshells = 5
 class CoreMultiShellModel(BaseComponent):
     """
@@ -42,6 +42,9 @@
         self._set_fixed_params()  
         
-        ## functional multiplicity of the model
-        self.multiplicity = 5
+        ## functional multiplicity info of the model
+        # [int(maximum no. of functionality),"str(Titl),
+        # [str(name of function0),...], [str(x-asix name of sld),...]]
+        self.multiplicity_info = [max_nshells,"No. of Shells:",[],['Radius']]
+
         ## parameters with orientation: can be removed since there is no orientational params
         for item in self.model.orientation_params:
@@ -91,5 +94,5 @@
             nshell = 0
             if name.split('_')[0] == 'thick' or name.split('_')[0] == 'sld':
-                if name.split('_')[1] == 'solv' or name.split('_')[1] == 'core':
+                if name.split('_')[1] == 'solv' or name.split('_')[1] == 'core0':
                     self.params[name]= value
                     continue
@@ -146,8 +149,8 @@
         # for core at r=0
         r.append(0)
-        beta.append(self.params['sld_core'])
+        beta.append(self.params['sld_core0'])
         # for core at r=rad_core
-        r.append(self.params['rad_core'])
-        beta.append(self.params['sld_core'])
+        r.append(self.params['rad_core0'])
+        beta.append(self.params['sld_core0'])
         
         # for shells
Index: sansmodels/src/sans/models/OnionModel.py
===================================================================
--- sansmodels/src/sans/models/OnionModel.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/OnionModel.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -38,6 +38,6 @@
          n_shells        = 1.0 
          scale           = 1.0 
-         rad_core        = 200.0 [A]
-         sld_core        = 1e-006 [1/A^(2)]
+         rad_core0       = 200.0 [A]
+         sld_core0       = 1e-006 [1/A^(2)]
          sld_solv        = 6.4e-006 [1/A^(2)]
          background      = 0.0 [1/cm]
@@ -122,7 +122,7 @@
 		
 		background:background,
-		rad_core: radius of sphere(core)
+		rad_core0: radius of sphere(core)
 		thick_shell#:the thickness of the shell#
-		sld_core: the SLD of the sphere
+		sld_core0: the SLD of the sphere
 		sld_solv: the SLD of the solvent
 		sld_shell: the SLD of the shell#
@@ -133,6 +133,6 @@
         self.details['n_shells'] = ['', None, None]
         self.details['scale'] = ['', None, None]
-        self.details['rad_core'] = ['[A]', None, None]
-        self.details['sld_core'] = ['[1/A^(2)]', None, None]
+        self.details['rad_core0'] = ['[A]', None, None]
+        self.details['sld_core0'] = ['[1/A^(2)]', None, None]
         self.details['sld_solv'] = ['[1/A^(2)]', None, None]
         self.details['background'] = ['[1/cm]', None, None]
@@ -189,5 +189,5 @@
 
         ## fittable parameters
-        self.fixed=['rad_core.width', 'thick_shell1.width', 'thick_shell2.width', 'thick_shell3.width', 'thick_shell4.width', 'thick_shell5.width', 'thick_shell6.width', 'thick_shell7.width', 'thick_shell8.width', 'thick_shell9.width', 'thick_shell10.width']
+        self.fixed=['rad_core0.width', 'thick_shell1.width', 'thick_shell2.width', 'thick_shell3.width', 'thick_shell4.width', 'thick_shell5.width', 'thick_shell6.width', 'thick_shell7.width', 'thick_shell8.width', 'thick_shell9.width', 'thick_shell10.width']
         
         ## non-fittable parameters
Index: sansmodels/src/sans/models/RPA10Model.py
===================================================================
--- sansmodels/src/sans/models/RPA10Model.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/RPA10Model.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -46,5 +46,15 @@
         
         ## functional multiplicity of the model
-        self.multiplicity = max_case_n
+        self.multiplicity_info = [max_case_n,"Case No.:",["C/D Binary Mixture of Homopolymers",
+                                                         "C-D Diblock Copolymer",
+                                                         "B/C/D Ternary Mixture of Homopolymers",
+                                                         "B/C-D Mixture of Homopolymer B and Diblock Copolymer C-D",
+                                                         "B-C-D Triblock Copolymer",
+                                                         "A/B/C/D Quaternary Mixture of Homopolymers",
+                                                         "A/B/C-D Mixture of Homopolymer A/B and Diblock C-D",
+                                                         "A/B-C-D Mixture of Homopolymer A and triblock B-C-D",
+                                                         "A-B/C-D Mixture of Diblock Copolymer A-B and Diblock C-D",
+                                                         "A-B-C-D Four-block Copolymer"],
+                                                         []]
     
     def _clone(self, obj):
Index: sansmodels/src/sans/models/ReflModel.py
===================================================================
--- sansmodels/src/sans/models/ReflModel.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/ReflModel.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -83,4 +83,16 @@
          func_inter9     = 0.0 
          func_inter10    = 0.0 
+         sldIM_flat1     = 0.0 
+         sldIM_flat2     = 0.0 
+         sldIM_flat3     = 0.0 
+         sldIM_flat4     = 0.0 
+         sldIM_flat5     = 0.0 
+         sldIM_flat6     = 0.0 
+         sldIM_flat7     = 0.0 
+         sldIM_flat8     = 0.0 
+         sldIM_flat9     = 0.0 
+         sldIM_flat10    = 0.0 
+         sldIM_sub0      = 0.0 
+         sldIM_medium    = 0.0 
 
     """
@@ -169,4 +181,16 @@
         self.details['func_inter9'] = ['', None, None]
         self.details['func_inter10'] = ['', None, None]
+        self.details['sldIM_flat1'] = ['', None, None]
+        self.details['sldIM_flat2'] = ['', None, None]
+        self.details['sldIM_flat3'] = ['', None, None]
+        self.details['sldIM_flat4'] = ['', None, None]
+        self.details['sldIM_flat5'] = ['', None, None]
+        self.details['sldIM_flat6'] = ['', None, None]
+        self.details['sldIM_flat7'] = ['', None, None]
+        self.details['sldIM_flat8'] = ['', None, None]
+        self.details['sldIM_flat9'] = ['', None, None]
+        self.details['sldIM_flat10'] = ['', None, None]
+        self.details['sldIM_sub0'] = ['', None, None]
+        self.details['sldIM_medium'] = ['', None, None]
 
         ## fittable parameters
Index: sansmodels/src/sans/models/ReflectivityModel.py
===================================================================
--- sansmodels/src/sans/models/ReflectivityModel.py	(revision 35aface36aa7573475600ebbacb987f50386d5f8)
+++ sansmodels/src/sans/models/ReflectivityModel.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -49,6 +49,9 @@
         self.model.params['n_layers'] = self.n_layers
         
-        ## functional multiplicity of the model
-        self.multiplicity = max_nshells
+        ## functional multiplicity info of the model
+        # [int(maximum no. of functionality),"str(Titl),
+        # [str(name of function0),...], [str(x-asix name of sld),...]]
+        self.multiplicity_info = [max_nshells,"No. of Layers:",[],['Depth']]
+
     
     def _clone(self, obj):
@@ -84,5 +87,7 @@
             n = 0
             pos = len(name.split('_'))-1
-            if name.split('_')[0] == 'func':
+            if name.split('_')[0] == 'sldIM':
+                continue
+            elif name.split('_')[0] == 'func':
                 n= -1
                 while n<self.n_layers:
@@ -141,5 +146,8 @@
                     if key.split('_')[1] == 'flat%s' % str(nshell+1):
                         try:
-                            value = self.model.params['sld_medium']
+                            if key.split('_')[0] == 'sld':
+                                value = self.model.params['sld_medium']
+                            elif key.split('_')[0] == 'sldIM':
+                                value = self.model.params['sldIM_medium']
                             self.model.setParam(key, value)
                         except: pass
Index: sansmodels/src/sans/models/SphereExpShellModel.py
===================================================================
--- sansmodels/src/sans/models/SphereExpShellModel.py	(revision fbae8817f74c42a391633060105ffce089adeff9)
+++ sansmodels/src/sans/models/SphereExpShellModel.py	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -39,4 +39,9 @@
         self._set_fixed_params()  
         self.model.params['n_shells'] = self.n_shells
+        ## functional multiplicity info of the model
+        # [int(maximum no. of functionality),"str(Titl),
+        # [str(name of function0),...], [str(x-asix name of sld),...]]
+        self.multiplicity_info = [max_nshells,"No. of Shells:",[],['Radius']]
+
         ## parameters with orientation: can be removed since there is no orientational params
         for item in self.model.orientation_params:
@@ -146,8 +151,8 @@
         # for core at r=0
         r.append(0)
-        beta.append(self.params['sld_core'])
+        beta.append(self.params['sld_core0'])
         # for core at r=rad_core
-        r.append(self.params['rad_core'])
-        beta.append(self.params['sld_core'])
+        r.append(self.params['rad_core0'])
+        beta.append(self.params['sld_core0'])
         
         # for shells
Index: sansmodels/src/sans/models/c_extensions/barbell.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/barbell.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/barbell.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -0,0 +1,174 @@
+/*
+ * Scattering model for a BarBell
+ */
+#include "barbell.h"
+#include <math.h>
+#include "GaussWeights.h"
+#include "libCylinder.h"
+
+/**
+ * Function to evaluate 1D scattering function
+ * @param pars: parameters of the BarBell
+ * @param q: q-value
+ * @return: function value
+ */
+double barbell_analytical_1D(BarBellParameters *pars, double q) {
+	double dp[7];
+	double result;
+
+	dp[0] = pars->scale;
+	dp[1] = pars->rad_bar;
+	dp[2] = pars->len_bar;
+	dp[3] = pars->rad_bell;
+	dp[4] = pars->sld_barbell;
+	dp[5] = pars->sld_solv;
+	dp[6] = pars->background;
+
+	result = Barbell(dp, q);
+	// Make Sure it never goes to inf/nan.
+	if ( result == INFINITY || result == NAN){
+		result = pars->background;
+	}
+	return result;
+}
+
+
+double bar2d_kernel(double dp[], double q, double alpha) {
+	int i,j;
+	double Pi;
+	double scale,contr,bkg,sldc,slds;
+	double len,rad,hDist,endRad;
+	int nordj=76;
+	double zi=alpha,yyy,answer;			//running tally of integration
+	double summj,vaj,vbj,zij;			//for the inner integration
+	double arg1,arg2,inner,be;
+
+
+	scale = dp[0];
+	rad = dp[1];
+	len = dp[2];
+	endRad = dp[3];
+	sldc = dp[4];
+	slds = dp[5];
+	bkg = dp[6];
+
+	hDist = sqrt(fabs(endRad*endRad-rad*rad));		//by definition for this model
+
+	contr = sldc-slds;
+
+	Pi = 4.0*atan(1.0);
+	vaj = -1.0*hDist/endRad;
+	vbj = 1.0;		//endpoints of inner integral
+
+	summj=0.0;
+
+	for(j=0;j<nordj;j++) {
+		//20 gauss points for the inner integral
+		zij = ( Gauss76Z[j]*(vbj-vaj) + vaj + vbj )/2.0;		//the "t" dummy
+		yyy = Gauss76Wt[j] * Dumb_kernel(dp,q,zij,zi);		//uses the same Kernel as the Dumbbell, here L>0
+		summj += yyy;
+	}
+	//now calculate the value of the inner integral
+	inner = (vbj-vaj)/2.0*summj;
+	inner *= 4.0*Pi*endRad*endRad*endRad;
+
+	//now calculate outer integrand
+	arg1 = q*len/2.0*cos(zi);
+	arg2 = q*rad*sin(zi);
+	yyy = inner;
+
+	if(arg2 == 0) {
+		be = 0.5;
+	} else {
+		be = NR_BessJ1(arg2)/arg2;
+	}
+
+	if(arg1 == 0.0) {		//limiting value of sinc(0) is 1; sinc is not defined in math.h
+		yyy += Pi*rad*rad*len*2.0*be;
+	} else {
+		yyy += Pi*rad*rad*len*sin(arg1)/arg1*2.0*be;
+	}
+	yyy *= yyy;   //sin(zi);
+	answer = yyy;
+
+
+	answer /= Pi*rad*rad*len + 2.0*Pi*(2.0*endRad*endRad*endRad/3.0+endRad*endRad*hDist-hDist*hDist*hDist/3.0);		//divide by volume
+	answer *= 1.0e8;		//convert to cm^-1
+	answer *= contr*contr;
+	answer *= scale;
+	answer += bkg;
+
+	return answer;
+}
+
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the BarBell
+ * @param q: q-value
+ * @return: function value
+ */
+double barbell_analytical_2DXY(BarBellParameters *pars, double qx, double qy){
+	double q;
+	q = sqrt(qx*qx+qy*qy);
+	return barbell_analytical_2D_scaled(pars, q, qx/q, qy/q);
+}
+
+double barbell_analytical_2D(BarBellParameters *pars, double q, double phi) {
+	return barbell_analytical_2D_scaled(pars, q, cos(phi), sin(phi));
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the BarBell
+ * @param q: q-value
+ * @param q_x: q_x / q
+ * @param q_y: q_y / q
+ * @return: function value
+ */
+double barbell_analytical_2D_scaled(BarBellParameters *pars, double q, double q_x, double q_y) {
+	double cyl_x, cyl_y, cyl_z;
+	double q_z;
+	double alpha, vol, cos_val;
+	double answer;
+	double dp[7];
+
+	dp[0] = pars->scale;
+	dp[1] = pars->rad_bar;
+	dp[2] = pars->len_bar;
+	dp[3] = pars->rad_bell;
+	dp[4] = pars->sld_barbell;
+	dp[5] = pars->sld_solv;
+	dp[6] = pars->background;
+
+
+	//double Pi = 4.0*atan(1.0);
+    // Cylinder orientation
+    cyl_x = sin(pars->theta) * cos(pars->phi);
+    cyl_y = sin(pars->theta) * sin(pars->phi);
+    cyl_z = cos(pars->theta);
+
+    // q vector
+    q_z = 0;
+
+    // Compute the angle btw vector q and the
+    // axis of the cylinder
+    cos_val = cyl_x*q_x + cyl_y*q_y + cyl_z*q_z;
+
+    // The following test should always pass
+    if (fabs(cos_val)>1.0) {
+    	printf("cyl_ana_2D: Unexpected error: cos(alpha)>1\n");
+     	return 0;
+    }
+
+    // Note: cos(alpha) = 0 and 1 will get an
+    // undefined value from CylKernel
+	alpha = acos( cos_val );
+
+	// Call the IGOR library function to get the kernel
+	answer = bar2d_kernel(dp, q, alpha)/sin(alpha);
+
+
+	return answer;
+
+}
Index: sansmodels/src/sans/models/c_extensions/barbell.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/barbell.h	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/barbell.h	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -0,0 +1,79 @@
+#if !defined(barbell_h)
+#define barbell_h
+
+/**
+ * Structure definition for BarBell parameters
+ */
+ //[PYTHONCLASS] = BarBellModel
+ //[DISP_PARAMS] = rad_bar,len_bar,rad_bell,phi,  theta
+ //[DESCRIPTION] =<text>Calculates the scattering from a barbell-shaped cylinder. That is
+ //				a sphereocylinder with spherical end caps
+ //				that have a radius larger than that of
+ //				the cylinder and the center of the end cap
+ //				radius lies outside of the cylinder.
+ //				Note: As the length of cylinder(bar) -->0,
+ //				it becomes a dumbbell.
+ //				And when rad_bar = rad_bell,
+ //				it is a spherocylinder.
+ //				It must be that rad_bar <(=) rad_bell.
+ //				[Parameters];
+ //				scale: volume fraction of spheres,
+ //				background:incoherent background,
+ //				rad_bar: radius of the cylindrical bar,
+ //				len_bar: length of the cylindrical bar,
+ //				rad_bell: radius of the spherical bell,
+ //				sld_barbell: SLD of the barbell,
+ //				sld_solv: SLD of the solvent.
+ //		</text>
+ //[FIXED]=  rad_bar.width;len_bar;rad_bell;phi.width; theta.width
+ //[ORIENTATION_PARAMS]= <text> phi; theta; phi.width; theta.width</text>
+
+typedef struct {
+    /// Scale factor
+    //  [DEFAULT]=scale= 1.0
+    double scale;
+
+    ///	rad_bar [A]
+    //  [DEFAULT]=rad_bar=20.0 [A]
+    double rad_bar;
+
+    ///	length of the bar [A]
+    //  [DEFAULT]=len_bar=400.0 [A]
+    double len_bar;
+
+    ///	Radius of sphere [A]
+    //  [DEFAULT]=rad_bell=40.0 [A]
+    double rad_bell;
+
+    ///	sld_barbell [1/A^(2)]
+    //  [DEFAULT]=sld_barbell= 1.0e-6 [1/A^(2)]
+    double sld_barbell;
+
+    ///	sld_solv [1/A^(2)]
+    //  [DEFAULT]=sld_solv= 6.3e-6 [1/A^(2)]
+    double sld_solv;
+
+	/// Incoherent Background [1/cm]
+	//  [DEFAULT]=background=0.0 [1/cm]
+	double background;
+
+    /// Angle of the main axis against z-axis in detector plane [rad]
+    //  [DEFAULT]=theta=0.0 [rad]
+    double theta;
+    /// Azimuthal angle around z-axis in detector plane [rad]
+    //  [DEFAULT]=phi=0.0 [rad]
+    double phi;
+
+} BarBellParameters;
+
+
+
+/// 1D scattering function
+double barbell_analytical_1D(BarBellParameters *pars, double q);
+
+/// 2D scattering function
+double barbell_analytical_2D(BarBellParameters *pars, double q, double phi);
+double barbell_analytical_2DXY(BarBellParameters *pars, double qx, double qy);
+double barbell_analytical_2D_scaled(BarBellParameters *pars, double q, double q_x, double q_y);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/capcyl.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/capcyl.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/capcyl.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -0,0 +1,174 @@
+/*
+ * Scattering model for a Capped Cylinder
+ */
+#include "capcyl.h"
+#include <math.h>
+#include "GaussWeights.h"
+#include "libCylinder.h"
+
+/**
+ * Function to evaluate 1D scattering function
+ * @param pars: parameters of the CappedCylinder
+ * @param q: q-value
+ * @return: function value
+ */
+double capcyl_analytical_1D(CapCylParameters *pars, double q) {
+	double dp[7];
+	double result;
+
+	dp[0] = pars->scale;
+	dp[1] = pars->rad_cyl;
+	dp[2] = pars->len_cyl;
+	dp[3] = pars->rad_cap;
+	dp[4] = pars->sld_capcyl;
+	dp[5] = pars->sld_solv;
+	dp[6] = pars->background;
+
+	result = CappedCylinder(dp, q);
+	// Make Sure it never goes to inf/nan.
+	if ( result == INFINITY || result == NAN){
+		result = pars->background;
+	}
+	return result;
+}
+
+
+double capcyl2d_kernel(double dp[], double q, double alpha) {
+	int i,j;
+	double Pi;
+	double scale,contr,bkg,sldc,slds;
+	double len,rad,hDist,endRad;
+	int nordj=76;
+	double zi=alpha,yyy,answer;			//running tally of integration
+	double summj,vaj,vbj,zij;			//for the inner integration
+	double arg1,arg2,inner,be;
+
+
+	scale = dp[0];
+	rad = dp[1];
+	len = dp[2];
+	endRad = dp[3];
+	sldc = dp[4];
+	slds = dp[5];
+	bkg = dp[6];
+
+	hDist = -1.0*sqrt(fabs(endRad*endRad-rad*rad));		//by definition for this model
+
+	contr = sldc-slds;
+
+	Pi = 4.0*atan(1.0);
+	vaj = -1.0*hDist/endRad;
+	vbj = 1.0;		//endpoints of inner integral
+
+	summj=0.0;
+
+	for(j=0;j<nordj;j++) {
+		//20 gauss points for the inner integral
+		zij = ( Gauss76Z[j]*(vbj-vaj) + vaj + vbj )/2.0;		//the "t" dummy
+		yyy = Gauss76Wt[j] * ConvLens_kernel(dp,q,zij,zi);		//uses the same Kernel as the Dumbbell, here L>0
+		summj += yyy;
+	}
+	//now calculate the value of the inner integral
+	inner = (vbj-vaj)/2.0*summj;
+	inner *= 4.0*Pi*endRad*endRad*endRad;
+
+	//now calculate outer integrand
+	arg1 = q*len/2.0*cos(zi);
+	arg2 = q*rad*sin(zi);
+	yyy = inner;
+
+	if(arg2 == 0) {
+		be = 0.5;
+	} else {
+		be = NR_BessJ1(arg2)/arg2;
+	}
+
+	if(arg1 == 0.0) {		//limiting value of sinc(0) is 1; sinc is not defined in math.h
+		yyy += Pi*rad*rad*len*2.0*be;
+	} else {
+		yyy += Pi*rad*rad*len*sin(arg1)/arg1*2.0*be;
+	}
+	yyy *= yyy;   //sin(zi);
+	answer = yyy;
+
+
+	answer /= Pi*rad*rad*len + 2.0*Pi*(2.0*endRad*endRad*endRad/3.0+endRad*endRad*hDist-hDist*hDist*hDist/3.0);		//divide by volume
+	answer *= 1.0e8;		//convert to cm^-1
+	answer *= contr*contr;
+	answer *= scale;
+	answer += bkg;
+
+	return answer;
+}
+
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the BarBell
+ * @param q: q-value
+ * @return: function value
+ */
+double capcyl_analytical_2DXY(CapCylParameters *pars, double qx, double qy){
+	double q;
+	q = sqrt(qx*qx+qy*qy);
+	return capcyl_analytical_2D_scaled(pars, q, qx/q, qy/q);
+}
+
+double capcyl_analytical_2D(CapCylParameters *pars, double q, double phi) {
+	return capcyl_analytical_2D_scaled(pars, q, cos(phi), sin(phi));
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the BarBell
+ * @param q: q-value
+ * @param q_x: q_x / q
+ * @param q_y: q_y / q
+ * @return: function value
+ */
+double capcyl_analytical_2D_scaled(CapCylParameters *pars, double q, double q_x, double q_y) {
+	double cyl_x, cyl_y, cyl_z;
+	double q_z;
+	double alpha, vol, cos_val;
+	double answer;
+	double dp[7];
+
+	dp[0] = pars->scale;
+	dp[1] = pars->rad_cyl;
+	dp[2] = pars->len_cyl;
+	dp[3] = pars->rad_cap;
+	dp[4] = pars->sld_capcyl;
+	dp[5] = pars->sld_solv;
+	dp[6] = pars->background;
+
+
+	//double Pi = 4.0*atan(1.0);
+    // Cylinder orientation
+    cyl_x = sin(pars->theta) * cos(pars->phi);
+    cyl_y = sin(pars->theta) * sin(pars->phi);
+    cyl_z = cos(pars->theta);
+
+    // q vector
+    q_z = 0;
+
+    // Compute the angle btw vector q and the
+    // axis of the cylinder
+    cos_val = cyl_x*q_x + cyl_y*q_y + cyl_z*q_z;
+
+    // The following test should always pass
+    if (fabs(cos_val)>1.0) {
+    	printf("cyl_ana_2D: Unexpected error: cos(alpha)>1\n");
+     	return 0;
+    }
+
+    // Note: cos(alpha) = 0 and 1 will get an
+    // undefined value from CylKernel
+	alpha = acos( cos_val );
+
+	// Call the IGOR library function to get the kernel
+	answer = capcyl2d_kernel(dp, q, alpha)/sin(alpha);
+
+
+	return answer;
+
+}
Index: sansmodels/src/sans/models/c_extensions/capcyl.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/capcyl.h	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_extensions/capcyl.h	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -0,0 +1,77 @@
+#if !defined(capcyl_h)
+#define capcyl_h
+
+/**
+ * Structure definition for CappedCylinder parameters
+ */
+ //[PYTHONCLASS] = CappedCylinderModel
+ //[DISP_PARAMS] = rad_cyl,len_cyl,rad_cap,phi,  theta
+ //[DESCRIPTION] =<text>Calculates the scattering from a cylinder with spherical
+ //				section end-caps. That is, a sphereocylinder
+ //				with end caps that have a radius larger than
+ //				that of the cylinder and the center of the
+ //				end cap radius lies within the cylinder.
+ //				Note: As the length of cylinder -->0,
+ //				it becomes a ConvexLens.
+ //				It must be that rad_cyl <(=) rad_cap.
+ //				[Parameters];
+ //				scale: volume fraction of spheres,
+ //				background:incoherent background,
+ //				rad_cyl: radius of the cylinder,
+ //				len_cyl: length of the cylinder,
+ //				rad_cap: radius of the semi-spherical cap,
+ //				sld_capcyl: SLD of the capped cylinder,
+ //				sld_solv: SLD of the solvent.
+ //		</text>
+ //[FIXED]=  rad_cyl.width;len_cyl;rad_cap;phi.width; theta.width
+ //[ORIENTATION_PARAMS]= <text> phi; theta; phi.width; theta.width</text>
+
+typedef struct {
+    /// Scale factor
+    //  [DEFAULT]=scale= 1.0
+    double scale;
+
+    ///	rad_cyl [A]
+    //  [DEFAULT]=rad_cyl=20.0 [A]
+    double rad_cyl;
+
+    ///	length of the cylinder
+    //  [DEFAULT]=len_cyl=400.0 [A]
+    double len_cyl;
+
+    ///	Radius of sphere [A]
+    //  [DEFAULT]=rad_cap=40.0 [A]
+    double rad_cap;
+
+    ///	sld_capcyl [1/A^(2)]
+    //  [DEFAULT]=sld_capcyl= 1.0e-6 [1/A^(2)]
+    double sld_capcyl;
+
+    ///	sld_solv [1/A^(2)]
+    //  [DEFAULT]=sld_solv= 6.3e-6 [1/A^(2)]
+    double sld_solv;
+
+	/// Incoherent Background [1/cm]
+	//  [DEFAULT]=background=0.0 [1/cm]
+	double background;
+
+    /// Angle of the main axis against z-axis in detector plane [rad]
+    //  [DEFAULT]=theta=0.0 [rad]
+    double theta;
+    /// Azimuthal angle around z-axis in detector plane [rad]
+    //  [DEFAULT]=phi=0.0 [rad]
+    double phi;
+
+} CapCylParameters;
+
+
+
+/// 1D scattering function
+double capcyl_analytical_1D(CapCylParameters *pars, double q);
+
+/// 2D scattering function
+double capcyl_analytical_2D(CapCylParameters *pars, double q, double phi);
+double capcyl_analytical_2DXY(CapCylParameters *pars, double qx, double qy);
+double capcyl_analytical_2D_scaled(CapCylParameters *pars, double q, double q_x, double q_y);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/corefourshell.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/corefourshell.c	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_extensions/corefourshell.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -18,6 +18,6 @@
 
 	dp[0] = pars->scale;
-	dp[1] = pars->rad_core;
-	dp[2] = pars->sld_core;
+	dp[1] = pars->rad_core0;
+	dp[2] = pars->sld_core0;
 	dp[3] = pars->thick_shell1;
 	dp[4] = pars->sld_shell1;
Index: sansmodels/src/sans/models/c_extensions/corefourshell.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/corefourshell.h	(revision c724ccd87499a21402fee0d11d517066f99ddf9b)
+++ sansmodels/src/sans/models/c_extensions/corefourshell.h	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -6,9 +6,9 @@
  */
  //[PYTHONCLASS] = CoreFourShellModel
- //[DISP_PARAMS] = rad_core, thick_shell1,thick_shell2,thick_shell3,thick_shell4
+ //[DISP_PARAMS] = rad_core0, thick_shell1,thick_shell2,thick_shell3,thick_shell4
  //[DESCRIPTION] =<text> Calculates the scattering intensity from a core-4 shell structure.
  // 			scale = scale factor * volume fraction
- //				rad_core: the radius of the core
- //				sld_core: the SLD of the core
+ //				rad_core0: the radius of the core
+ //				sld_core0: the SLD of the core
  //				thick_shelli: the thickness of the i'th shell from the core
  //				sld_shelli: the SLD of the i'th shell from the core
@@ -16,5 +16,5 @@
  //				background: incoherent background
  //		</text>
- //[FIXED]=<text>  thick_shell4.width; thick_shell1.width;thick_shell2.width;thick_shell3.width;rad_core.width </text>
+ //[FIXED]=<text>  thick_shell4.width; thick_shell1.width;thick_shell2.width;thick_shell3.width;rad_core0.width </text>
  //[ORIENTATION_PARAMS]= <text> </text>
 
@@ -24,11 +24,11 @@
     double scale;
 
-    ///	Radius of the core [A]
-    //  [DEFAULT]=rad_core=60. [A]
-    double rad_core;
+    ///	Radius of the core0 [A]
+    //  [DEFAULT]=rad_core0=60. [A]
+    double rad_core0;
 
-    ///	sld of core [1/A^(2)]
-    //  [DEFAULT]=sld_core= 6.4e-6 [1/A^(2)]
-    double sld_core;
+    ///	sld of core0 [1/A^(2)]
+    //  [DEFAULT]=sld_core0= 6.4e-6 [1/A^(2)]
+    double sld_core0;
 
     ///	thickness of the shell1 [A]
Index: sansmodels/src/sans/models/c_extensions/fcc.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/fcc.c	(revision d5b6a9d7cd9e26b5f9e28e55e8cf848a40de6ae9)
+++ sansmodels/src/sans/models/c_extensions/fcc.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -65,5 +65,5 @@
 	double answer;
 	double Pi = 4.0*atan(1.0);
-	double aa, Da, qDa_2, latticeScale, Zq, Fkq, Fkq_2;
+	double aa, Da, qDa_2, latticeScale, Zq, Fkq, Fkq_2,contrast;
 
 	double dp[5];
@@ -77,4 +77,5 @@
 	Da = pars->d_factor*aa;
 	qDa_2 = pow(q*Da,2.0);
+	contrast = pars->sldSph - pars->sldSolv;
 
 	latticeScale = 4.0*(4.0/3.0)*Pi*(dp[1]*dp[1]*dp[1])/pow(aa*sqrt(2.0),3.0);
@@ -133,5 +134,5 @@
 
 	// Use SphereForm directly from libigor
-	answer = SphereForm(dp,q)*Zq;
+	answer = SphereForm_Paracrystal(pars->radius,contrast,q)*Zq;
 
 	//consider scales
Index: sansmodels/src/sans/models/c_extensions/onion.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/onion.c	(revision a1b247163dd00d4b19fd556819b00a9ccf638299)
+++ sansmodels/src/sans/models/c_extensions/onion.c	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
@@ -11,6 +11,6 @@
 	int n = dp[0];
 	double scale = dp[1];
-	double rad_core = dp[2];
-	double sld_core = dp[3];
+	double rad_core0 = dp[2];
+	double sld_core0 = dp[3];
 	double sld_solv = dp[4];
 	double background = dp[5];
@@ -30,9 +30,9 @@
 		fun_type[i] = dp[i+45];
 	}
-	sld_out[0] = sld_core;
+	sld_out[0] = sld_core0;
 	sld_out[n+1] = sld_solv;
-	sld_in[0] = sld_core;
+	sld_in[0] = sld_core0;
 	sld_in[n+1] = sld_solv;
-	thick[0] = rad_core;
+	thick[0] = rad_core0;
 	thick[n+1] = 1e+10;
 	A[0] = 0.0;
@@ -69,5 +69,5 @@
 					}
 					else{
-						slope[i] = (sld_out[i]-sld_in[i])/(exp(A[i])-1);
+						slope[i] = (sld_out[i]-sld_in[i])/(exp(A[i])-1.0);
 					}
                     for (j=0; j<2; j++){
@@ -174,6 +174,6 @@
 	dp[0] = pars->n_shells;
 	dp[1] = pars->scale;
-	dp[2] = pars->rad_core;
-	dp[3] = pars->sld_core;
+	dp[2] = pars->rad_core0;
+	dp[3] = pars->sld_core0;
 	dp[4] = pars->sld_solv;
 	dp[5] = pars->background;
